/*=========================================================================
*
*  Copyright Insight Software Consortium
*
*  Licensed under the Apache License, Version 2.0 (the "License");
*  you may not use this file except in compliance with the License.
*  You may obtain a copy of the License at
*
*         http://www.apache.org/licenses/LICENSE-2.0.txt
*
*  Unless required by applicable law or agreed to in writing, software
*  distributed under the License is distributed on an "AS IS" BASIS,
*  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*  See the License for the specific language governing permissions and
*  limitations under the License.
*
*=========================================================================*/
#ifndef sitkSliceImageFilter_h
#define sitkSliceImageFilter_h

/*
 * WARNING: DO NOT EDIT THIS FILE!
 * THIS FILE IS AUTOMATICALLY GENERATED BY THE SIMPLEITK BUILD PROCESS.
 * Please look at sitkImageFilterTemplate.h.in to make changes.
 */

#include <memory>

#include "sitkBasicFilters.h"
#include "sitkImageFilter.h"

namespace itk {
  namespace simple {

    /**\class SliceImageFilter



\sa itk::simple::Slice for the procedural interface
\sa itk::SliceImageFilter for the Doxygen on the original ITK class.
     */
    class SITKBasicFilters_EXPORT SliceImageFilter : public ImageFilter<1> {
    public:
      typedef SliceImageFilter Self;

      /** Default Constructor that takes no arguments and initializes
       * default parameters */
      SliceImageFilter();

      /** Destructor */
      ~SliceImageFilter();

      /** Define the pixels types supported by this filter */
      typedef NonLabelPixelIDTypeList  PixelIDTypeList;



      /**
       */
      SITK_RETURN_SELF_TYPE_HEADER SetStart ( const std::vector<int32_t> & Start ) { this->m_Start = Start; return *this; }

      /**
       */
        std::vector<int32_t> GetStart() const { return this->m_Start; }

      /**
       */
      SITK_RETURN_SELF_TYPE_HEADER SetStop ( const std::vector<int32_t> & Stop ) { this->m_Stop = Stop; return *this; }

      /**
       */
        std::vector<int32_t> GetStop() const { return this->m_Stop; }

      /**
       */
      SITK_RETURN_SELF_TYPE_HEADER SetStep ( const std::vector<int> & Step ) { this->m_Step = Step; return *this; }

      /** Set the values of the Step vector all to value */
      SITK_RETURN_SELF_TYPE_HEADER SetStep( int value ) { this->m_Step = std::vector<int>(3, value); return *this; }


      /**
       */
        std::vector<int> GetStep() const { return this->m_Step; }
      /** Name of this class */
      std::string GetName() const { return std::string ("SliceImageFilter"); }

      /** Print ourselves out */
      std::string ToString() const;


      /** Execute the filter on the input image */
      Image Execute ( const Image& image1 );


      /** Execute the filter on the input image with the given parameters */
      Image Execute ( const Image& image1, const std::vector<int32_t> & start, const std::vector<int32_t> & stop, const std::vector<int> & step );


    private:

      /** Setup for member function dispatching */

      typedef Image (Self::*MemberFunctionType)( const Image& image1 );
      template <class TImageType> Image ExecuteInternal ( const Image& image1 );



      friend struct detail::MemberFunctionAddressor<MemberFunctionType>;

      nsstd::auto_ptr<detail::MemberFunctionFactory<MemberFunctionType> > m_MemberFactory;


      std::vector<int32_t>  m_Start;
      std::vector<int32_t>  m_Stop;
      std::vector<int>  m_Step;
    };



    /**
     * \brief itk::simple::SliceImageFilter Procedural Interface
     *
     * This function directly calls the execute method of SliceImageFilter
     * in order to support a procedural API
     *
     * \sa itk::simple::SliceImageFilter for the object oriented interface
     */
     SITKBasicFilters_EXPORT Image Slice ( const Image& image1, const std::vector<int32_t> & start = std::vector<int32_t>(3, 0), const std::vector<int32_t> & stop = std::vector<int32_t>(3, std::numeric_limits<int32_t>::max()), const std::vector<int> & step = std::vector<int>(3, 1) );

  }
}
#endif
